/**
 *
 * @author    Jerry Bendy
 * @since     7/23/2018
 */
import webCommon from './web-common';
import ajax from './ajax'
import forceResolveHTTPS from './forceResolveHTTPS'

export default function getUploadToken(params) {
    ajax.post({
        url: webCommon.getApiDomain() + 'qiniuUpload/app/get-token',
        data: {
            type: params.type || 'common'
        },
        success: function(data) {
            if (data.status === 200) {
                // 如果接口返回了 action 并且当前页面是 HTTPS，尝试解析地址为 HTTPS
                if (data.data.action) {
                    data.data.action = forceResolveHTTPS(data.data.action)
                }
                params.success(data.data)

            } else {
                params.error(data.message)
            }
        },
        error: function(err) {

        }
    })
}
