/**
 * MixPanel 支持
 * @author    Jerry Bendy
 * @since     10/9/2018
 */
import callBridge from './callBridge'

export function initMixPanel() {
    /**
     * 代码来自 MixPanel 官方提供的 Javascript API
     * @see https://mixpanel.com/help/reference/javascript
     */
    (function(e, a) {
        if (!a.__SV) {
            var b = window;
            try {
                var c, l, i, j = b.location, g = j.hash;
                c = function(a, b) {
                    return (l = a.match(RegExp(b + "=([^&]*)"))) ? l[1] : null
                };
                g && c(g, "state") && (i = JSON.parse(decodeURIComponent(c(g, "state"))), "mpeditor" === i.action && (b.sessionStorage.setItem("_mpcehash", g), history.replaceState(i.desiredHash || "", e.title, j.pathname + j.search)))
            } catch (m) {
            }
            var k, h;
            window.mixpanel = a;
            a._i = [];
            a.init = function(b, c, f) {
                function e(b, a) {
                    var c = a.split(".");
                    2 == c.length && (b = b[c[0]], a = c[1]);
                    b[a] = function() {
                        b.push([a].concat(Array.prototype.slice.call(arguments,
                            0)))
                    }
                }

                var d = a;
                "undefined" !== typeof f ? d = a[f] = [] : f = "mixpanel";
                d.people = d.people || [];
                d.toString = function(b) {
                    var a = "mixpanel";
                    "mixpanel" !== f && (a += "." + f);
                    b || (a += " (stub)");
                    return a
                };
                d.people.toString = function() {
                    return d.toString(1) + ".people (stub)"
                };
                k = "disable time_event track track_pageview track_links track_forms register register_once alias unregister identify name_tag set_config reset opt_in_tracking opt_out_tracking has_opted_in_tracking has_opted_out_tracking clear_opt_in_out_tracking people.set people.set_once people.unset people.increment people.append people.union people.track_charge people.clear_charges people.delete_user".split(" ");
                for (h = 0; h < k.length; h++) e(d, k[h]);
                a._i.push([b, c, f])
            };
            a.__SV = 1.2;
            b = e.createElement("script");
            b.type = "text/javascript";
            b.async = !0;
            b.src = "//cdn.ifuli.cn/libs/mixpanel/vendor/mixpanel-2-latest.min.js";  // 此处有改动，换成 ifuli 的 CDN
            c = e.getElementsByTagName("script")[0];
            c.parentNode.insertBefore(b, c)
        }
    })(document, window.mixpanel || []);

    // 根据环境初始化 token
    var token = /ifuli\.cn/i.test(location.host) ? '848d437a079d831d9a47956172bc0fdf' :
        (/pockethr\.tech/i.test(location.host) ? 'ad570dcae0d155bf01e52d4e47a73fae' : '3d787fa51d1dc1513e75667ab22cd99a')

    mixpanel.init(token);

    // 标识用户信息
    var userInfo = callBridge('GET_USER_INFO');
    mixpanel.identify(userInfo.userId || 'UNKNOWN USER');
}

export function trackEvent(eventName, properties) {
    // 添加默认的记录项
    var userInfo = callBridge('GET_USER_INFO');
    properties = Object.assign(properties || {}, {
        UserID: userInfo.userId || 0,
        'Company ID': userInfo.companyId || -1,
        'Company En Name': ''
    });

    mixpanel.track(eventName, properties);
}
